﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.IO.Ports;
using System.Windows.Threading;
using System.Threading;




namespace TPS929120
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        byte flaga1 = 0;
        SerialPort serial1;

        byte flagatimerek = 0;
        volatile string czas;
        volatile static int sekundy;
        volatile static int minuty;
        volatile static int godzina;
        volatile string stringh, stringm, strings;
        static int ti;
        string[] portytemp = { "0" };
        byte adres1;  //adres pierwszego drivera TPS
        byte[] temparray = new byte[5];
        byte[] forcrc = new byte[3];
        byte[] iconf = new byte[] {0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f, 0x3f };
        byte[] pwmconf = new byte[] { 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff };
        int enablechannel = 0;
        byte[] channelarray = new byte[12];
        byte[] receivetps2 = new byte[300];
        byte[] temparray2 = new byte[4];
        byte[] forcrc2 = new byte[2];
        byte[] temparray3 = new byte[5];
        byte[] forcrc3 = new byte[3];
        byte[] eepia = new byte[12];
        byte[] eeppa = new byte[12];
        byte[] eepma = new byte[15];
        byte eepcrc = 0;
        Int16 value = 0;


        public MainWindow()
        {
            InitializeComponent();
            nazwyportow();
            predkosci();

            mojlabel.Visibility = System.Windows.Visibility.Hidden;
            wska.Fill = new SolidColorBrush(Color.FromRgb(255, 0, 0));
            rozlaczb.IsEnabled = false; //wylaczenie przycisku rozlacz
            wyslijb.IsEnabled = false;

            nserial.IsEnabled = true;
            sserial.IsEnabled = true;
            tpsadr.IsEnabled = true;

            odczyt.IsEnabled = false;
            Program.IsEnabled = false;
            fail.IsEnabled = false;
            normal.IsEnabled = false;

            showiconf(); //wyswietlenie wartosci rejestrow conf
            showpwmconf();
            enabdisabcells(false);


            if (flaga1 == 1)
            {

                flaga1 = 0;
            }
            SetTimer();
            TIMEREK();
        }

        void nazwyportow()  //tutaj nastepuje pobranie wszstkich nazw portow do tablicy oraz wpisanie ich do Comboboxa
        {

            string[] porty = SerialPort.GetPortNames();


            if ((porty.Length) == (portytemp.Length))
            {
                var result = porty.Except(portytemp).ToArray();
                if (result.Count() == 0)
                {
                }
                else
                {
                    porty.CopyTo(portytemp, 0);
                    nserial.Items.Clear();

                    for (int k = 0; k < porty.Length; k++) //petla wpisujaca dostepne porty do comboboxa
                    {
                        nserial.Items.Add(porty[k]);
                    }
                }
            }
            else
            {
                portytemp = porty;
                nserial.Items.Clear();

                for (int k = 0; k < porty.Length; k++) //petla wpisujaca dostepne porty do comboboxa
                {
                    nserial.Items.Add(porty[k]);
                }
            }
        }

        void predkosci()  //wpisanie dostepnch predkosci do wyboru
        {
            string[] predkosci = { "9600", "19200", "38400", "57600", "115200", "256000" };

            for (int k = 0; k < predkosci.Length; k++)
            {
                sserial.Items.Add(predkosci[k]);
            }
        }


        void TIMEREK()
        {
            if (flagatimerek == 0)  //pierwsze pobranie informacji o sekundach w systemie
            {
                flagatimerek = 1;
                //czas=DateTime.Now.Second.ToString(); //pobranie informacji o sekundach
                sekundy = DateTime.Now.Second;
                minuty = DateTime.Now.Minute;
                godzina = DateTime.Now.Hour;
            }

            //wyswietlenie godziny
            stringh = godzina.ToString();
            stringm = minuty.ToString();
            strings = sekundy.ToString();
            czas = godzina + ":";
            czas += minuty + ":";
            czas += sekundy;
            oknoczasu.Text = czas;
        }

        //Zdarzenie dzialajace na przycisk rozlacz
        private void rozlacz(object sender, RoutedEventArgs e)
        {
            if (flaga1 == 1)
            {
                serial1.Close(); //zamkniecie portu szeregowego
                flaga1 = 0;
                wska.Fill = new SolidColorBrush(Color.FromRgb(255, 0, 0));

                polaczb.IsEnabled = true; //wylaczenie przycisku oraz zalaczenie drugiego
                rozlaczb.IsEnabled = false;
                wyslijb.IsEnabled = false;

                nserial.IsEnabled = true;
                sserial.IsEnabled = true;
                tpsadr.IsEnabled = true;
                odczyt.IsEnabled = false;
                Program.IsEnabled = false;
                fail.IsEnabled = false;
                normal.IsEnabled = false;
                Program.IsEnabled = false;
                normal.IsEnabled = false;
                fail.IsEnabled = false;

                enabdisabcells(false);
            }

        }

        //ustawienie timera
        public void SetTimer()
        {
            DispatcherTimer Timerek = new DispatcherTimer();

            Timerek.Tick += dispatcherTimer_Tick;
            Timerek.Interval = new TimeSpan(0, 0, 1); //zwiekszenie co 1 sekund
            Timerek.Start();
        }


        //zdarzenie co jedna sekunde od timera
        public void dispatcherTimer_Tick(object sender, EventArgs e)
        {
            if (ti != 0) ti--;
            sekundy++;
            //zmiana czasu
            if (sekundy > 59)
            {
                sekundy = 0;
                minuty++;
                if (minuty > 59)
                {
                    minuty = 0;
                    godzina++;
                    if (godzina > 23) godzina = 0;
                }
            }

            //zmiana wartosci godziny
            stringh = godzina.ToString();
            if (godzina < 10) stringh = "0" + stringh;
            stringm = minuty.ToString();
            if (minuty < 10) stringm = "0" + stringm;
            strings = sekundy.ToString();
            if (sekundy < 10) strings = "0" + strings;

            czas = stringh + ":";
            czas += stringm + ":";
            czas += strings;
            oknoczasu.Text = czas;

            //w tym miejscu nastepuje sprawdzenie aktualnego stanu portow UART
            nazwyportow();

            
        }

        //sprawdzenie adresu tps929120
        private void tpsadres(object sender, TextChangedEventArgs e)
        {     
            //warunki niedopuszczajace do pobrania nieprawidlowego adresu
            string tempstring = tpsadr.Text;
            if(tempstring=="")
            {
                tempstring = "0";
            }
            byte valuebyte;
            valuebyte = Convert.ToByte(tempstring);
            if (valuebyte > 15)
            {
                valuebyte = 15;
            }
            adres1=valuebyte;  //przypisanie adresu do zmiennej globalnej
            tempstring = Convert.ToString(valuebyte);
            tpsadr.Text = tempstring;
        }

        private void Polacz(object sender, RoutedEventArgs e)
        {

            if ((sserial.Text == "") || (nserial.Text == ""))  //jezeli nie wybrano ktorejkolwiek opji z comboboxa to
            {
                mojlabel.Visibility = System.Windows.Visibility.Visible;
            }
            else if (flaga1 == 0)
            {
                mojlabel.Visibility = System.Windows.Visibility.Hidden;
                wska.Fill = new SolidColorBrush(Color.FromRgb(0, 255, 0));

                serial1 = new SerialPort(); //utowrzenie portu szeregowego

                serial1.PortName = nserial.Text;                   //dla portu szeregowego wybranie portu
                serial1.BaudRate = Convert.ToInt32(sserial.Text); //nadanie predkosci
                serial1.Parity = Parity.None;
                serial1.DataBits = 8;

                serial1.DataReceived += new SerialDataReceivedEventHandler(ReceivedHandler);

                serial1.Open(); //otwarcie portu 

                flaga1 = 1;
                polaczb.IsEnabled = false; //wylaczenie przycisku oraz zalaczenie drugiego
                rozlaczb.IsEnabled = true;
                wyslijb.IsEnabled = true;

                if((sserial.Text=="115200" || sserial.Text=="256000"))
                {
                    if (flaga1 == 1)
                    {
                        odczyt.IsEnabled = true;
                  
                    }
                }

                nserial.IsEnabled = false;  //zablokowanie komorek sluzacych do ustawienia polaczenia
                sserial.IsEnabled = false;
                tpsadr.IsEnabled = false;
                fail.IsEnabled = true;
                normal.IsEnabled = true;

                fail.IsEnabled = true;
                normal.IsEnabled = true;

            }
        }

        //Funkcja ktora powoduje wyslanie danych do TPS929120
        private void wyslijdane(object sender, RoutedEventArgs e)
        {
            datatosend(adres1, 0x61, 0x00);
           

            for(int k=0; k<12; k++)
            {
                datatosend(adres1, (byte)k, iconf[k]);         
            }

            for (int k = 0; k < 12; k++)
            {
                datatosend(adres1, (byte)(k+0x20), pwmconf[k]);     
            }
  
            datatosend(adres1, 0x50, (byte)(enablechannel));     
            datatosend(adres1, 0x51, (byte)(enablechannel>>8));
        }

        //odbliczenie sumy kontrolnej z n bajtow
        public byte CRCcalculator(byte[] bytes, byte initval)
        {
            const byte generator = 0x31;
            byte crc = 0;
            bytes[0] = (byte)(bytes[0] ^ initval);

            foreach (byte currByte in bytes)
            {
                crc ^= currByte;

                for (int i = 0; i < 8; i++)
                {
                    if ((crc & 0x80) != 0)
                    {
                        crc = (byte)((crc << 1) ^ generator);
                    }
                    else
                    {
                        crc <<= 1;
                    }
                }
            }

            return crc;
        }

        //odwrocenie wszystkich bajtow - Reflected
        public void Reflect8(byte[] val, byte numberofbytes)
        {
            byte resVal = 0;

            for (int s = 0; s < numberofbytes; s++)
            {
                resVal = 0;

                for (int i = 0; i < 8; i++)
                {
                    if ((val[s] & (1 << i)) != 0)
                    {
                        resVal |= (byte)(1 << (7 - i));
                    }
                }
                val[s] = resVal;
            }
        }
        //funkcja za pomoca ktorej wysylamy bajt jesli serial jest polaczony
        public void sendvalue(byte[] tempvar)
        {
            if(flaga1!=0) //jesli jest przeprowadzone polaczenie
            {
                serial1.Write(tempvar, 0, tempvar.Length);
            }
        }

        //ograniczenia dla wartosci
        private void conf0(object sender, TextChangedEventArgs e)
        {
            string tempstring;
            tempstring = iconf0.Text;
            if (tempstring == "") tempstring = "0";
            iconf[0] = (byte)Convert.ToInt16(tempstring);
            if (iconf[0] > 63) iconf[0] = 63;
            iconf0.Text = Convert.ToString(iconf[0]);
        }

        private void conf1(object sender, TextChangedEventArgs e)
        {
            string tempstring;
            tempstring = iconf1.Text;
            if (tempstring == "") tempstring = "0";
            iconf[1] =(byte)Convert.ToInt16(tempstring);
            if (iconf[1] > 63) iconf[1] = 63;
            iconf1.Text = Convert.ToString(iconf[1]);
        }

        private void conf2(object sender, TextChangedEventArgs e)
        {
            string tempstring;
            tempstring = iconf2.Text;
            if (tempstring == "") tempstring = "0";
            iconf[2] = (byte)Convert.ToInt16(tempstring);
            if (iconf[2] > 63) iconf[2] = 63;
            iconf2.Text = Convert.ToString(iconf[2]);
        }

        private void conf3(object sender, TextChangedEventArgs e)
        {
            string tempstring;
            tempstring = iconf3.Text;
            if (tempstring == "") tempstring = "0";
            iconf[3] = (byte)Convert.ToInt16(tempstring);
            if (iconf[3] > 63) iconf[3] = 63;
            iconf3.Text = Convert.ToString(iconf[3]);
        }

        private void conf4(object sender, TextChangedEventArgs e)
        {
            string tempstring;
            tempstring = iconf4.Text;
            if (tempstring == "") tempstring = "0";
            iconf[4] = (byte)Convert.ToInt16(tempstring);
            if (iconf[4] > 63) iconf[4] = 63;
            iconf4.Text = Convert.ToString(iconf[4]);
        }

        private void conf5(object sender, TextChangedEventArgs e)
        {
            string tempstring;
            tempstring = iconf5.Text;
            if (tempstring == "") tempstring = "0";
            iconf[5] = (byte)Convert.ToInt16(tempstring);
            if (iconf[5] > 63) iconf[5] = 63;
            iconf5.Text = Convert.ToString(iconf[5]);
        }

        private void conf6(object sender, TextChangedEventArgs e)
        {
            string tempstring;
            tempstring = iconf6.Text;
            if (tempstring == "") tempstring = "0";
            iconf[6] = (byte)Convert.ToInt16(tempstring);
            if (iconf[6] > 63) iconf[6] = 63;
            iconf6.Text = Convert.ToString(iconf[6]);
        }

        private void conf7(object sender, TextChangedEventArgs e)
        {
            string tempstring;
            tempstring = iconf7.Text;
            if (tempstring == "") tempstring = "0";
            iconf[7] = (byte)Convert.ToInt16(tempstring);
            if (iconf[7] > 63) iconf[7] = 63;
            iconf7.Text = Convert.ToString(iconf[7]);
        }

        private void conf8(object sender, TextChangedEventArgs e)
        {
            string tempstring;
            tempstring = iconf8.Text;
            if (tempstring == "") tempstring = "0";
            iconf[8] = (byte)Convert.ToInt16(tempstring);
            if (iconf[8] > 63) iconf[8] = 63;
            iconf8.Text = Convert.ToString(iconf[8]);
        }

        private void conf9(object sender, TextChangedEventArgs e)
        {
            string tempstring;
            tempstring = iconf9.Text;
            if (tempstring == "") tempstring = "0";
            iconf[9] = (byte)Convert.ToInt16(tempstring);
            if (iconf[9] > 63) iconf[9] = 63;
            iconf9.Text = Convert.ToString(iconf[9]);
        }

        private void conf10(object sender, TextChangedEventArgs e)
        {
            string tempstring;
            tempstring = iconf10.Text;
            if (tempstring == "") tempstring = "0";
            iconf[10] = (byte)Convert.ToInt16(tempstring);
            if (iconf[10] > 63) iconf[10] = 63;
            iconf10.Text = Convert.ToString(iconf[10]);
        }

        private void conf11(object sender, TextChangedEventArgs e)
        {
            string tempstring;
            tempstring = iconf11.Text;
            if (tempstring == "") tempstring = "0";
            iconf[11] = (byte)Convert.ToInt16(tempstring);
            if (iconf[11] > 63) iconf[11] = 63;
            iconf11.Text = Convert.ToString(iconf[11]);
        }

        

        private void epwm0(object sender, TextChangedEventArgs e)
        {
            string tempstring;
            Int16 temptemp;
            tempstring = pwm0.Text;
            if (tempstring == "") tempstring = "0";
            temptemp = Convert.ToInt16(tempstring);
            if (temptemp > 255) temptemp = 255;
            pwmconf[0] =(byte)temptemp;
            pwm0.Text = Convert.ToString(pwmconf[0]);
        }

        private void epwm1(object sender, TextChangedEventArgs e)
        {
            string tempstring;
            Int16 temptemp;
            tempstring = pwm1.Text;
            if (tempstring == "") tempstring = "0";
            temptemp = Convert.ToInt16(tempstring);
            if (temptemp > 255) temptemp = 255;
            pwmconf[1] = (byte)temptemp;
            pwm1.Text = Convert.ToString(pwmconf[1]);
        }

        private void epwm2(object sender, TextChangedEventArgs e)
        {
            string tempstring;
            Int16 temptemp;
            tempstring = pwm2.Text;
            if (tempstring == "") tempstring = "0";
            temptemp = Convert.ToInt16(tempstring);
            if (temptemp > 255) temptemp = 255;
            pwmconf[2] = (byte)temptemp;
            pwm2.Text = Convert.ToString(pwmconf[2]);
        }

        private void epwm3(object sender, TextChangedEventArgs e)
        {
            string tempstring;
            Int16 temptemp;
            tempstring = pwm3.Text;
            if (tempstring == "") tempstring = "0";
            temptemp = Convert.ToInt16(tempstring);
            if (temptemp > 255) temptemp = 255;
            pwmconf[3] = (byte)temptemp;
            pwm3.Text = Convert.ToString(pwmconf[3]);
        }

        private void epwm4(object sender, TextChangedEventArgs e)
        {
            string tempstring;
            Int16 temptemp;
            tempstring = pwm4.Text;
            if (tempstring == "") tempstring = "0";
            temptemp = Convert.ToInt16(tempstring);
            if (temptemp > 255) temptemp = 255;
            pwmconf[4] = (byte)temptemp;
            pwm4.Text = Convert.ToString(pwmconf[4]);
        }

        private void epwm5(object sender, TextChangedEventArgs e)
        {
            string tempstring;
            Int16 temptemp;
            tempstring = pwm5.Text;
            if (tempstring == "") tempstring = "0";
            temptemp = Convert.ToInt16(tempstring);
            if (temptemp > 255) temptemp = 255;
            pwmconf[5] = (byte)temptemp;
            pwm5.Text = Convert.ToString(pwmconf[5]);
        }

        private void epwm6(object sender, TextChangedEventArgs e)
        {
            string tempstring;
            Int16 temptemp;
            tempstring = pwm6.Text;
            if (tempstring == "") tempstring = "0";
            temptemp = Convert.ToInt16(tempstring);
            if (temptemp > 255) temptemp = 255;
            pwmconf[6] = (byte)temptemp;
            pwm6.Text = Convert.ToString(pwmconf[6]);
        }

        private void epwm7(object sender, TextChangedEventArgs e)
        {
            string tempstring;
            Int16 temptemp;
            tempstring = pwm7.Text;
            if (tempstring == "") tempstring = "0";
            temptemp = Convert.ToInt16(tempstring);
            if (temptemp > 255) temptemp = 255;
            pwmconf[7] = (byte)temptemp;
            pwm7.Text = Convert.ToString(pwmconf[7]);
        }

        private void epwm8(object sender, TextChangedEventArgs e)
        {
            string tempstring;
            Int16 temptemp;
            tempstring = pwm8.Text;
            if (tempstring == "") tempstring = "0";
            temptemp = Convert.ToInt16(tempstring);
            if (temptemp > 255) temptemp = 255;
            pwmconf[8] = (byte)temptemp;
            pwm8.Text = Convert.ToString(pwmconf[8]);
        } 

        private void epwm9(object sender, TextChangedEventArgs e)
        {
            string tempstring;
            Int16 temptemp;
            tempstring = pwm9.Text;
            if (tempstring == "") tempstring = "0";
            temptemp = Convert.ToInt16(tempstring);
            if (temptemp > 255) temptemp = 255;
            pwmconf[9] = (byte)temptemp;
            pwm9.Text = Convert.ToString(pwmconf[9]);
        }

        private void epwm10(object sender, TextChangedEventArgs e)
        {
            string tempstring;
            Int16 temptemp;
            tempstring = pwm10.Text;
            if (tempstring == "") tempstring = "0";
            temptemp = Convert.ToInt16(tempstring);
            if (temptemp > 255) temptemp = 255;
            pwmconf[10] = (byte)temptemp;
            pwm10.Text = Convert.ToString(pwmconf[10]);
        }

        private void epwm11(object sender, TextChangedEventArgs e)
        {
            string tempstring;
            Int16 temptemp;
            tempstring = pwm11.Text;
            if (tempstring == "") tempstring = "0";
            temptemp = Convert.ToInt16(tempstring);
            if (temptemp > 255) temptemp = 255;
            pwmconf[11] = (byte)temptemp;
            pwm11.Text = Convert.ToString(pwmconf[11]);
        }


        //funkcja ktora przygotowuje dane do wyslania do tps
        public void datatosend(byte adress_tps, byte register, byte value)
        {    
            temparray[0]= 0x55;
            temparray[1] = (byte)(adress_tps | 0x80);
            temparray[2] = register;
            temparray[3] = value;

            forcrc[0]= (byte)(adress_tps | 0x80);
            forcrc[1] = register;
            forcrc[2] = value;

            Reflect8(forcrc, 3);
            temparray[4]=CRCcalculator(forcrc, 0xff);

            sendvalue(temparray);
            System.Threading.Thread.Sleep(10);  //opoznienie 10ms

            
        }
        
        public byte readdata(byte adress_tps, byte register)
        {
            byte result = 0;
            byte tt = 0;

            temparray2[0] = 0x55;
            temparray2[1] = (byte)(adress_tps | 0x00);
            temparray2[2] = register;
            
            forcrc2[0] = (byte)(adress_tps | 0x00);
            forcrc2[1] = register;

            Reflect8(forcrc2, 2);
            temparray2[3] = CRCcalculator(forcrc2, 0xff);

            sendvalue(temparray2);
            System.Threading.Thread.Sleep(60);  //opoznienie 50ms

            byte[] temparray = new byte[5];
            forcrc3[0] = receivetps2[0];
            forcrc3[1] = receivetps2[1];

            Reflect8(forcrc3, 1);
            tt=CRCcalculator(forcrc3, 0xff);

            if (tt == 0) //jesli CRC jest prawidlowo tzn prawidlwo odebrano dana wtedy wynik funkcji zwraca dana odebrana
            {
                result = receivetps2[0];
            }
            

            return result;
        }

        private void ech0(object sender, RoutedEventArgs e)
        {
            enablechannel = 0;
            if (ch0.IsChecked == true)
            {
                channelarray[0] = 1;
            }
            else
            {
                channelarray[0] = 0;
            }
            enablechannel = (channelarray[11] << 11) | (channelarray[10] << 10) | (channelarray[9] << 9) | (channelarray[8] << 8) | (channelarray[7] << 7) | (channelarray[6] << 6) | (channelarray[5] << 5) | (channelarray[4] << 4) |
                (channelarray[3] << 3) | (channelarray[2] << 2) | (channelarray[1] << 1) | (channelarray[0] << 0);
        }

        private void ech1(object sender, RoutedEventArgs e)
        {
            enablechannel = 0;
            if (ch1.IsChecked == true)
            {
                channelarray[1] = 1;
            }
            else
            {
                channelarray[1] = 0;
            }
            enablechannel = (channelarray[11] << 11) | (channelarray[10] << 10) | (channelarray[9] << 9) | (channelarray[8] << 8) | (channelarray[7] << 7) | (channelarray[6] << 6) | (channelarray[5] << 5) | (channelarray[4] << 4) |
                (channelarray[3] << 3) | (channelarray[2] << 2) |  (channelarray[1] << 1) | (channelarray[0] << 0);
        }

        private void ech2(object sender, RoutedEventArgs e)
        {
            enablechannel = 0;
            if (ch2.IsChecked == true)
            {
                channelarray[2] = 1;
            }
            else
            {
                channelarray[2] = 0;
            }
            enablechannel = (channelarray[11] << 11) | (channelarray[10] << 10) | (channelarray[9] << 9) | (channelarray[8] << 8) | (channelarray[7] << 7) | (channelarray[6] << 6) | (channelarray[5] << 5) | (channelarray[4] << 4) |
                (channelarray[3] << 3) | (channelarray[2] << 2) |  (channelarray[1] << 1) | (channelarray[0] << 0);
        }

        private void ech3(object sender, RoutedEventArgs e)
        {
            enablechannel = 0;
            if (ch3.IsChecked == true)
            {
                channelarray[3] = 1;
            }
            else
            {
                channelarray[3] = 0;
            }
            enablechannel = (channelarray[11] << 11) | (channelarray[10] << 10) | (channelarray[9] << 9) | (channelarray[8] << 8) | (channelarray[7] << 7) | (channelarray[6] << 6) | (channelarray[5] << 5) | (channelarray[4] << 4) |
                (channelarray[3] << 3) | (channelarray[2] << 2) |  (channelarray[1] << 1) | (channelarray[0] << 0);
        }

        private void ech4(object sender, RoutedEventArgs e)
        {
            enablechannel = 0;
            if (ch4.IsChecked == true)
            {
                channelarray[4] = 1;
            }
            else
            {
                channelarray[4] = 0;
            }
            enablechannel = (channelarray[11] << 11) | (channelarray[10] << 10) | (channelarray[9] << 9) | (channelarray[8] << 8) | (channelarray[7] << 7) | (channelarray[6] << 6) | (channelarray[5] << 5) | (channelarray[4] << 4) |
                (channelarray[3] << 3) | (channelarray[2] << 2) |  (channelarray[1] << 1) | (channelarray[0] << 0);
        }

        private void ech5(object sender, RoutedEventArgs e)
        {
            enablechannel = 0;
            if (ch5.IsChecked == true)
            {
                channelarray[5] = 1;
            }
            else
            {
                channelarray[5] = 0;
            }
            enablechannel = (channelarray[11] << 11) | (channelarray[10] << 10) | (channelarray[9] << 9) | (channelarray[8] << 8) | (channelarray[7] << 7) | (channelarray[6] << 6) | (channelarray[5] << 5) | (channelarray[4] << 4) |
                (channelarray[3] << 3) | (channelarray[2] << 2) |  (channelarray[1] << 1) | (channelarray[0] << 0);
        }

        private void ech6(object sender, RoutedEventArgs e)
        {
            enablechannel = 0;
            if (ch6.IsChecked == true)
            {
                channelarray[6] = 1;
            }
            else
            {
                channelarray[6] = 0;
            }
            enablechannel = (channelarray[11] << 11) | (channelarray[10] << 10) | (channelarray[9] << 9) | (channelarray[8] << 8) | (channelarray[7] << 7) | (channelarray[6] << 6) | (channelarray[5] << 5) | (channelarray[4] << 4) |
                (channelarray[3] << 3) | (channelarray[2] << 2) |  (channelarray[1] << 1) | (channelarray[0] << 0);
        }

        private void ech7(object sender, RoutedEventArgs e)
        {
            enablechannel = 0;
            if (ch7.IsChecked == true)
            {
                channelarray[7] = 1;
            }
            else
            {
                channelarray[7] = 0;
            }
            enablechannel = (channelarray[11] << 11) | (channelarray[10] << 10) | (channelarray[9] << 9) | (channelarray[8] << 8) | (channelarray[7] << 7) | (channelarray[6] << 6) | (channelarray[5] << 5) | (channelarray[4] << 4) |
                (channelarray[3] << 3) | (channelarray[2] << 2) |  (channelarray[1] << 1) | (channelarray[0] << 0);
        }

        private void ech8(object sender, RoutedEventArgs e)
        {
            enablechannel = 0;
            if (ch8.IsChecked == true)
            {
                channelarray[8] = 1;
            }
            else
            {
                channelarray[8] = 0;
            }
            enablechannel = (channelarray[11] << 11) | (channelarray[10] << 10) | (channelarray[9] << 9) | (channelarray[8] << 8) | (channelarray[7] << 7) | (channelarray[6] << 6) | (channelarray[5] << 5) | (channelarray[4] << 4) |
                (channelarray[3] << 3) | (channelarray[2] << 2) |  (channelarray[1] << 1) | (channelarray[0] << 0);
        }

        private void ech9(object sender, RoutedEventArgs e)
        {
            enablechannel = 0;
            if (ch9.IsChecked == true)
            {
                channelarray[9] = 1;
            }
            else
            {
                channelarray[9] = 0;
            }
            enablechannel = (channelarray[11] << 11) | (channelarray[10] << 10) | (channelarray[9] << 9) | (channelarray[8] << 8) | (channelarray[7] << 7) | (channelarray[6] << 6) | (channelarray[5] << 5) | (channelarray[4] << 4) |
                (channelarray[3] << 3) | (channelarray[2] << 2) |  (channelarray[1] << 1) | (channelarray[0] << 0);
        }

        private void ech10(object sender, RoutedEventArgs e)
        {
            enablechannel = 0;
            if (ch10.IsChecked == true)
            {
                channelarray[10] = 1;
            }
            else
            {
                channelarray[10] = 0;
            }
            enablechannel = (channelarray[11] << 11) | (channelarray[10] << 10) | (channelarray[9] << 9) | (channelarray[8] << 8) | (channelarray[7] << 7) | (channelarray[6] << 6) | (channelarray[5] << 5) | (channelarray[4] << 4) |
                (channelarray[3] << 3) | (channelarray[2] << 2) |  (channelarray[1] << 1) | (channelarray[0] << 0);
        }

        private void ech11(object sender, RoutedEventArgs e)
        {
            enablechannel = 0;
            if (ch11.IsChecked == true)
            {
                channelarray[11] = 1;
            }
            else
            {
                channelarray[11] = 0;
            }
            enablechannel = (channelarray[11] << 11) | (channelarray[10] << 10) | (channelarray[9] << 9) | (channelarray[8] << 8) | (channelarray[7] << 7) | (channelarray[6] << 6) | (channelarray[5] << 5) | (channelarray[4] << 4) |
                (channelarray[3] << 3) | (channelarray[2] << 2) |  (channelarray[1] << 1) | (channelarray[0] << 0);
        }

      

        //wysiwetlenie w tekstbox wartosci
        public void showiconf()
        {
            iconf0.Text = Convert.ToString(iconf[0]);
            iconf1.Text = Convert.ToString(iconf[1]);
            iconf2.Text = Convert.ToString(iconf[2]);
            iconf3.Text = Convert.ToString(iconf[3]);
            iconf4.Text = Convert.ToString(iconf[4]);
            iconf5.Text = Convert.ToString(iconf[5]);
            iconf6.Text = Convert.ToString(iconf[6]);
            iconf7.Text = Convert.ToString(iconf[7]);
            iconf8.Text = Convert.ToString(iconf[8]);
            iconf9.Text = Convert.ToString(iconf[9]);
            iconf10.Text = Convert.ToString(iconf[10]);
            iconf11.Text = Convert.ToString(iconf[11]);
        }

        private void odczytaj(object sender, RoutedEventArgs e)
        {
           

            for(int k=0; k<12; k++)
            {
               eepia[k]=readdata(adres1, (byte)(0x80 + k));           
            }

            ei0.Text= Convert.ToString(eepia[0]);
            ei1.Text = Convert.ToString(eepia[1]);
            ei2.Text = Convert.ToString(eepia[2]);
            ei3.Text = Convert.ToString(eepia[3]);
            ei4.Text = Convert.ToString(eepia[4]);
            ei5.Text = Convert.ToString(eepia[5]);
            ei6.Text = Convert.ToString(eepia[6]);
            ei7.Text = Convert.ToString(eepia[7]);
            ei8.Text = Convert.ToString(eepia[8]);
            ei9.Text = Convert.ToString(eepia[9]);
            ei10.Text = Convert.ToString(eepia[10]);
            ei11.Text = Convert.ToString(eepia[11]);

            for(int k=0; k<12; k++)
            {
                eeppa[k]= readdata(adres1, (byte)(0xa0 + k));
            }

            ep0.Text = Convert.ToString(eeppa[0]);
            ep1.Text = Convert.ToString(eeppa[1]);
            ep2.Text = Convert.ToString(eeppa[2]);
            ep3.Text = Convert.ToString(eeppa[3]);
            ep4.Text = Convert.ToString(eeppa[4]);
            ep5.Text = Convert.ToString(eeppa[5]);
            ep6.Text = Convert.ToString(eeppa[6]);
            ep7.Text = Convert.ToString(eeppa[7]);
            ep8.Text = Convert.ToString(eeppa[8]);
            ep9.Text = Convert.ToString(eeppa[9]);
            ep10.Text = Convert.ToString(eeppa[10]);
            ep11.Text = Convert.ToString(eeppa[11]);
            
            for(int k=0; k<15; k++)
            {
                eepma[k] = readdata(adres1, (byte)(0xc0 + k));
            }

            em0.Text = Convert.ToString(eepma[0]);
            em1.Text = Convert.ToString(eepma[1]);
            em2.Text = Convert.ToString(eepma[2]);
            em3.Text = Convert.ToString(eepma[3]);
            em4.Text = Convert.ToString(eepma[4]);
            em5.Text = Convert.ToString(eepma[5]);
            em6.Text = Convert.ToString(eepma[6]);
            em7.Text = Convert.ToString(eepma[7]);
            em8.Text = Convert.ToString(eepma[8]);
            em9.Text = Convert.ToString(eepma[9]);
            em10.Text = Convert.ToString(eepma[10]);
            em11.Text = Convert.ToString(eepma[11]);

            eepcrc= readdata(adres1, 0xcf);

            em15.Text = Convert.ToString(eepcrc);

            enabdisabcells(true);

            Program.IsEnabled = true;
        }

        //wyswietlenie w textboxie wartosci
        public void showpwmconf()
        {
            pwm0.Text = Convert.ToString(pwmconf[0]);
            pwm1.Text = Convert.ToString(pwmconf[1]);
            pwm2.Text = Convert.ToString(pwmconf[2]);
            pwm3.Text = Convert.ToString(pwmconf[3]);
            pwm4.Text = Convert.ToString(pwmconf[4]);
            pwm5.Text = Convert.ToString(pwmconf[5]);
            pwm6.Text = Convert.ToString(pwmconf[6]);
            pwm7.Text = Convert.ToString(pwmconf[7]);
            pwm8.Text = Convert.ToString(pwmconf[8]);
            pwm9.Text = Convert.ToString(pwmconf[9]);
            pwm10.Text = Convert.ToString(pwmconf[10]);
            pwm11.Text = Convert.ToString(pwmconf[11]);
        }

        private void eti0(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = ei0.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eepia[0] = (byte)value;
                ei0.Text = Convert.ToString(eepia[0]);
            }
        }

        private void eti1(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = ei1.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eepia[1] = (byte)value;
                ei1.Text = Convert.ToString(eepia[1]);
            }
        }

        private void eti2(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = ei2.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eepia[2] = (byte)value;
                ei2.Text = Convert.ToString(eepia[2]);
            }
        }

        private void eti3(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = ei3.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eepia[3] = (byte)value;
                ei3.Text = Convert.ToString(eepia[3]);
            }
        }

        private void eti4(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = ei4.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eepia[4] = (byte)value;
                ei4.Text = Convert.ToString(eepia[4]);
            }
        }

        private void eti5(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = ei5.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eepia[5] = (byte)value;
                ei5.Text = Convert.ToString(eepia[5]);
            }
        }

        private void eti6(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = ei6.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eepia[6] = (byte)value;
                ei6.Text = Convert.ToString(eepia[6]);
            }
        }

        private void eti7(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = ei7.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eepia[7] = (byte)value;
                ei7.Text = Convert.ToString(eepia[7]);
            }
        }

        private void eti8(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = ei8.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eepia[8] = (byte)value;
                ei8.Text = Convert.ToString(eepia[8]);
            }
        }

        private void eti9(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = ei9.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eepia[9] = (byte)value;
                ei9.Text = Convert.ToString(eepia[9]);
            }
        }

        private void eti10(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = ei10.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eepia[10] = (byte)value;
                ei10.Text = Convert.ToString(eepia[10]);
            }
        }

        private void eti11(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = ei11.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eepia[11] = (byte)value;
                ei11.Text = Convert.ToString(eepia[11]);
            }
        }

        private void etp0(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = ep0.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eeppa[0] = (byte)value;
                ep0.Text = Convert.ToString(eeppa[0]);
            }
        }

        private void etp1(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = ep1.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eeppa[1] = (byte)value;
                ep1.Text = Convert.ToString(eeppa[1]);
            }
        }

        private void etp2(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = ep2.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eeppa[2] = (byte)value;
                ep2.Text = Convert.ToString(eeppa[2]);
            }
        }

        private void etp3(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = ep3.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eeppa[3] = (byte)value;
                ep3.Text = Convert.ToString(eeppa[3]);
            }
        }

        private void etp4(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = ep4.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eeppa[4] = (byte)value;
                ep4.Text = Convert.ToString(eeppa[4]);
            }
        }

        private void etp5(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = ep5.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eeppa[5] = (byte)value;
                ep5.Text = Convert.ToString(eeppa[5]);
            }
        }

        private void etp6(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = ep6.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eeppa[6] = (byte)value;
                ep6.Text = Convert.ToString(eeppa[6]);
            }
        }

        private void etp7(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = ep7.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eeppa[7] = (byte)value;
                ep7.Text = Convert.ToString(eeppa[7]);
            }
        }

        private void etp8(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = ep8.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eeppa[8] = (byte)value;
                ep8.Text = Convert.ToString(eeppa[8]);
            }
        }

        private void etp9(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = ep9.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eeppa[9] = (byte)value;
                ep9.Text = Convert.ToString(eeppa[9]);
            }
        }

        private void etp10(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = ep10.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eeppa[10] = (byte)value;
                ep10.Text = Convert.ToString(eeppa[10]);
            }
        }

        private void etp11(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = ep11.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eeppa[11] = (byte)value;
                ep11.Text = Convert.ToString(eeppa[11]);
            }
        }

        private void etm0(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = em0.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eepma[0] = (byte)value;
                em0.Text = Convert.ToString(eepma[0]);
            }
        }

        private void etm1(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = em1.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eepma[1] = (byte)value;
                em1.Text = Convert.ToString(eepma[1]);
            }
        }

        private void etm2(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = em2.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eepma[2] = (byte)value;
                em2.Text = Convert.ToString(eepma[2]);
            }
        }

        private void etm3(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = em3.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eepma[3] = (byte)value;
                em3.Text = Convert.ToString(eepma[3]);
            }
        }

        private void etm4(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = em4.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eepma[4] = (byte)value;
                em4.Text = Convert.ToString(eepma[4]);
            }
        }

        private void etm5(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = em5.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eepma[5] = (byte)value;
                em5.Text = Convert.ToString(eepma[5]);
            }
        }

        private void etm6(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = em6.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eepma[6] = (byte)value;
                em6.Text = Convert.ToString(eepma[6]);
            }
        }

        private void etm7(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = em7.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eepma[7] = (byte)value;
                em7.Text = Convert.ToString(eepma[7]);
            }
        }

        private void etm8(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = em8.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eepma[8] = (byte)value;
                em8.Text = Convert.ToString(eepma[8]);
            }
        }

        private void etm9(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = em9.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eepma[9] = (byte)value;
                em9.Text = Convert.ToString(eepma[9]);
            }
        }

        private void etm10(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = em10.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eepma[10] = (byte)value;
                em10.Text = Convert.ToString(eepma[10]);
            }
        }

        private void etm11(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = em11.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eepma[11] = (byte)value;
                em11.Text = Convert.ToString(eepma[11]);
            }
        }

        private void etm15(object sender, TextChangedEventArgs e)
        {
            string te1;
            te1 = em15.Text;
            if (te1 == "") te1 = "0";
            if (te1 != "-")
            {
                value = Convert.ToInt16(te1);
                if (value > 255) value = 255;
                eepcrc = (byte)value;
                em15.Text = Convert.ToString(eepcrc);
            }
        }

        //Zaprogramowanie pamieci eeprom
        private void programeep(object sender, RoutedEventArgs e)
        {
            byte[] temporary = new byte[39];
            byte crcee = 0;


          

            datatosend(adres1, 0x61, 0x00); //odblokowanie eeprom

            datatosend(adres1, 0x65, 0x00);
            datatosend(adres1, 0x65, 0x02);
            datatosend(adres1, 0x65, 0x01);
            datatosend(adres1, 0x65, 0x09);
            datatosend(adres1, 0x65, 0x02);
            datatosend(adres1, 0x65, 0x09);

            datatosend(adres1, 0x63, 0x01);
            datatosend(adres1, 0x62, 0x80);


            //Tutaj nastepuje zapisanie wszystkich wartosci
            for(int k=0; k<12; k++)
            {
                datatosend(adres1, (byte)(0x80+k), eepia[k]); 
            }

            for (int k = 0; k < 12; k++)
            {
                datatosend(adres1, (byte)(0xA0 + k), eeppa[k]);
            }

            for (int k = 0; k < 12; k++)
            {
                datatosend(adres1, (byte)(0xC0 + k), eepma[k]);
            }

           

            //Uruchomienie zapisu do eeprom
            datatosend(adres1, 0x64, 0x04);
            System.Threading.Thread.Sleep(500);  //opoznienie 10ms//delay 500ms
            datatosend(adres1, 0x62, 0x00);


            for (int z = 0; z < 12; z++)
            {
                temporary[z] = eepia[z];
            }
            for (int z = 0; z < 12; z++)
            {
                temporary[z + 12] = eeppa[z];
            }
            for (int z = 0; z < 15; z++)
            {
                temporary[z + 24] = eepma[z];
            }
            
          

            Reflect8(temporary, 39);
            crcee = CRCcalculator(temporary, 0xff);

          

            datatosend(adres1, 0x65, 0x00);
            datatosend(adres1, 0x65, 0x02);
            datatosend(adres1, 0x65, 0x01);
            datatosend(adres1, 0x65, 0x09);
            datatosend(adres1, 0x65, 0x02);
            datatosend(adres1, 0x65, 0x09);

            datatosend(adres1, 0x63, 0x01);
            datatosend(adres1, 0x62, 0x80);

            datatosend(adres1, 0xcf, crcee);

            //Uruchomienie zapisu do eeprom
            datatosend(adres1, 0x64, 0x04);
            System.Threading.Thread.Sleep(500);  //opoznienie 10ms //delay 500ms
            datatosend(adres1, 0x62, 0x00);

        }

        //Wejscie do trybu normal z trybu fail state
        private void normalclick(object sender, RoutedEventArgs e)
        {
            datatosend(adres1, 0x61, 0x00);
            datatosend(adres1, 0x60, 0x04);
        }

        //wejscie do trybu fail state
        private void failclick(object sender, RoutedEventArgs e)
        {
            byte temp = readdata(adres1, 0x60);
            temp =(byte)(temp & (~(1 << 2)));

          //  byte kiki= readdata(adres1, 0x77);
          //  kik.Text = Convert.ToString(kiki);


            datatosend(adres1, 0x61, 0x00);
            datatosend(adres1, 0x60,(byte)(temp|0x20));
        }

        //wylaczenie lub zalaczenie komorek od pamieci eeprom
        public void enabdisabcells(Boolean tf)
        {
            ei0.IsEnabled = tf;
            ei1.IsEnabled = tf;
            ei2.IsEnabled = tf;
            ei3.IsEnabled = tf;
            ei4.IsEnabled = tf;
            ei5.IsEnabled = tf;
            ei6.IsEnabled = tf;
            ei7.IsEnabled = tf;
            ei8.IsEnabled = tf;
            ei9.IsEnabled = tf;
            ei10.IsEnabled = tf;
            ei11.IsEnabled = tf;

            ep0.IsEnabled = tf;
            ep1.IsEnabled = tf;
            ep2.IsEnabled = tf;
            ep3.IsEnabled = tf;
            ep4.IsEnabled = tf;
            ep5.IsEnabled = tf;
            ep6.IsEnabled = tf;
            ep7.IsEnabled = tf;
            ep8.IsEnabled = tf;
            ep9.IsEnabled = tf;
            ep10.IsEnabled = tf;
            ep11.IsEnabled = tf;

            em0.IsEnabled = tf;
            em1.IsEnabled = tf;
            em2.IsEnabled = tf;
            em3.IsEnabled = tf;
            em4.IsEnabled = tf;
            em5.IsEnabled = tf;
            em6.IsEnabled = tf;
            em7.IsEnabled = tf;
            em8.IsEnabled = tf;
            em9.IsEnabled = tf;
            em10.IsEnabled = tf;
            em11.IsEnabled = tf;

            em15.IsEnabled = tf;

        }

        //przerwanie od odebrania danej
        public void ReceivedHandler( object sender, SerialDataReceivedEventArgs e)
         {
            serial1.Read(receivetps2, 0, serial1.BytesToRead);
         }

    }


}


