#include "btapp.h"

volatile unsigned char btbuff[300];
volatile uint16_t uart2rx=0;
volatile uint32_t timerbt;


//opoznienie delay w ms
void delaybt(uint32_t time)
{
	timerbt=time*10;
	while(timerbt);
}

//Procedura string za pomoca USART3 - Bluetooth
void sendstring(char string[])
{
	char *s;

	s=string;
	while(*s)
	{
		while(USART_GetFlagStatus(USART3, USART_FLAG_TXE) == RESET)
		{

		}
		    	USART_SendData(USART3, (uint16_t)*s);
				s++;
	}
	while(USART_GetFlagStatus(USART3, USART_FLAG_TXE) == RESET); //odczekanie az bufor do wysylania bedzie pusty
}

//funkcja czyszczaca caly bufor odbiorczy BT
void cleanbtbuff(void)
{
	for(uint16_t i=0; i<300; i++)	btbuff[i]=0;   //wpisanie samych zer do bufora odbiorczego
}

//Funkcja przeszukujaca buffor po odebraniu okreslonej danej
void seekBT( unsigned char *wsk, uint16_t flagrx, uint8_t *ret1, uint8_t *ret2)
{
     volatile uint16_t i=0, j=0, k=0, l=0;
     static uint16_t tempflag=0;
	unsigned char *s1, *s2, *s3, *s4;
	static uint8_t flagaprogram=0;

	if(tempflag!=flagrx) //jezeli nastapilo odebranie danych to naley sprawdzic caly bufor odbiorczy
	{
		tempflag=flagrx;

		for(i=0; i<300; i++) //przeszukanie calego bufora odbiorczego
		{
			j=i+1;
			k=i+2;
			l=i+3;
			if(j>299) j=j-300;
			if(k>299) k=k-300;
			if(l>299) l=l-300;

			s1=wsk+i;
			s2=wsk+j;
			s3=wsk+k;
			s4=wsk+l;

			if(*s1=='s'  && *s4=='k')
			{
				if(flagaprogram)
				{
					timerbt=timedefprog; //jesli wykryto okreslona dana to wyczyszczenie licznika odliczajacego czas do konca mozliwosci programowania
					//ponizej znajduje sie procedura co nalezy zmienic podczas odbierania danych
					*ret1=*s2;
					*ret2=*s3;

					*s1=0; *s2=0, *s3=0, *s4=0; //wykasowanie odebranej danej
				}
				else if(*s2=='p' && *s3=='p')
				{
					flagaprogram=1; //ustawienie flagi
					timerbt=timedefprog; //zezwolenie na wysylanie danych przez 20s

					*s1=0; *s2=0, *s3=0, *s4=0; //wykasowanie odebranej danej
				}
			}
		}
	}
	if(flagaprogram && !timerbt) // wykasowanie zezwolenia na zaprogramowanie bt
	{
		flagaprogram=0;
	}
}

//Ustawienie odpowiedniej wartosci dla kontrolera w zaleznosci od otrzymanych instrukcji
void setsettingsBT(uint8_t *in1, uint8_t *in2, uint8_t *animpwr, uint8_t *animst, uint8_t *pwrled, uint8_t *amst, uint8_t *red, uint8_t *green, uint8_t *blue, uint8_t *tresh, uint8_t *time, uint8_t *state, uint8_t *direction, uint8_t *activdiag)
{

	if(*in1)
	{
		if(*in1=='a') //animacj power led
		{
			if((*in2>='0') && (*in2<='4'))
			{
				*animpwr=*in2-'0';
			}
		}
		if(*in1=='B') //animacja schodow
		{
			if((*in2>='0') && (*in2<='5'))
			{
				*animst=*in2-'0';
			}
		}
		if(*in1=='c') //moc power led
		{
			if((*in2>=0) && (*in2<=100))
			{
				*pwrled=*in2;
			}
		}
		if(*in1=='D') //ilosc schodow
		{
			if((*in2>=1) && (*in2<=24))
			{
				*amst=*in2;
			}
		}
		if(*in1=='e') //kolor czerwony
		{
				*red=*in2;
		}
		if(*in1=='F') //kolor zielony
		{
			   *green=*in2;
		}
		if(*in1=='g') //kolor niebieski
		{
			   *blue=*in2;
		}
		if(*in1=='H')
		{
			if(*in2<=30) *tresh=*in2;
		}
		if(*in1=='i')
		{
			if(*in2<=200) *time=*in2;
		}
		if(*in1=='J')
		{
				if(*in2=='A')
				{
						if(*state) *state=0; else *state=1;
						*direction=1;
				}
		}
		if(*in1=='k')
		{
				if(*in2=='Z')
				{
					if(*state) *state=0; else *state=1;
					*direction=2;
				}
		}
		if(*in1=='L')
		{
			if(*in2=='d')  *activdiag=1;
		}

		*in1=0; //wykasowanie zezwolenia na wejscie do programu
		*in2=0; //wykasowanie wartosci
	}
}

//Funkcja ktra jest wywolywana przy pierwszym uruchomieniu sterownika w celu zmiany nazwy modulu BT oraz ustawienia prawidlowej predkosci
void setupBT(void)
{
	        USART_InitTypeDef  USART_InitStructure;

	        USART_Cmd(USART3, DISABLE);  //wylaczenie UARTU a nastepnie zmiana parametrow na tryb AT+Command
	        USART_InitStructure.USART_BaudRate =38400;
		    USART_InitStructure.USART_WordLength = USART_WordLength_8b;                     //Dlugosc slowa = 8 bitow
		    USART_InitStructure.USART_StopBits = USART_StopBits_1;                          //1 bit stopu
		    USART_InitStructure.USART_Parity = USART_Parity_No;                             //Brak kontroli parzystosci
		    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None; //Kontrola przeplywu danych (brak)
		    USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;	                //Tryb pracy
		    USART_Init(USART3, &USART_InitStructure);
		    USART_ITConfig(USART3, USART_IT_RXNE, ENABLE);  	                       	//zalaczenie przerwania od USART
		    USART_Cmd(USART3, ENABLE);  //zalaczenie konfiguracji

		    ATbton; //zalaczenie trybu command
		    delaybt(3000); //odczekanie 3s

		    //Glowny kod zmiany ustawien modulu bluetooth
		    sendstring("AT+NAME=-SCL-BT-\r\n");
		    delaybt(1000); //odczekanie 300ms
		    sendstring("AT+UART=9600,0,0\r\n");
		    delaybt(1000); //odczekanie 300ms
		    sendstring("AT+RESET\r\n");
		    ATbtoff; //wylaczenie trybu command
		    delaybt(1000); //odczekanie 300ms


		    USART_Cmd(USART3, DISABLE);  //wylaczenie UARTU a nastepnie zmiana parametrow na odbierania danych
		    USART_InitStructure.USART_BaudRate =9600;
		    USART_InitStructure.USART_WordLength = USART_WordLength_8b;                     //Dlugosc slowa = 8 bitow
		    USART_InitStructure.USART_StopBits = USART_StopBits_1;                          //1 bit stopu
		    USART_InitStructure.USART_Parity = USART_Parity_No;                             //Brak kontroli parzystosci
		    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None; //Kontrola przeplywu danych (brak)
		    USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;	                //Tryb pracy
		    USART_Init(USART3, &USART_InitStructure);
		    USART_ITConfig(USART3, USART_IT_RXNE, ENABLE);  	                       	//zalaczenie przerwania od USART
		    USART_Cmd(USART3, ENABLE);  //zalaczenie konfiguracji

		    delaybt(100); //odczekanie 100ms
}


