#include "diagnostic.h"

volatile uint32_t diagtime1, diagtime2, diagtime3, timerclear;

//okreslenie maksymalnej wartosci napiecia na wyjsciu przetwornika
uint16_t maxvoltage(uint8_t amoundstair, uint16_t *s, uint8_t state)
{
	static uint8_t count=0, adress=0, out=0, flaga=0;
	uint16_t maxvalue=0;
	uint16_t *wsk;

	if(state)
	{
	if(!diagtime1)
		{
		if(count>=(amoundstair*3))
		{
			count=0;
			flaga=1;
		}

		adress=count/12;
		out=count%12;

		wsk=s+count;

		*wsk=calcvalueADC(adress, 0x1B-out);

		if(flaga) //zezwolenie na przeszukanie bufora danych i okreslenie maksymalnej wartosci napiecia
		{
			flaga=0;
			maxvalue=0;

			for(uint8_t i=0; i<(amoundstair*3); i++)
			{
				wsk=s+i;
				if(*wsk>maxvalue) maxvalue=*wsk; //wyszukanie maksymalnej wartosci
			}
		}

		count++;
		diagtime1=750; //interwal czasowy
		}
	}

	return maxvalue;
}

//Funkcja odczytujaca diagnostyke przerwy pomiedzy wyjsciami
uint8_t  openload(uint8_t amoundstairs, uint16_t *s, uint8_t state)
{
	uint8_t ret=0, adrrtemp;
	static uint8_t count=0;
	static uint8_t adress=0, tempadress=0xff;
	uint16_t *wsk;
	static uint16_t z1, z2;

	wsk=s;

	if(state)
	{
	if(!diagtime2)
	{

		if(count>=amoundstairs)
		{
			count=0;
		}

		adress=count/4;
		if(adress!=tempadress)
		{
			 tempadress=adress;

			 adrrtemp=(amoundstairs-1)/4; //obliczenie ostatniego adresu
			 if(adrrtemp==tempadress) ret=1;
			 z1=Read_data_TPS(tempadress, 0x7B);
			 z2=Read_data_TPS(tempadress, 0x7C);
			 z2=(z2&0x0f);
			 z1=z1|(z2<<8);

			 uint8_t i=0;
			 for(int z=11; z>=0; z--)
			 {
				 wsk=(uint16_t *)(s+(tempadress*12)+i);
				 *wsk=(z1>>z)&(0x01);
				 i++;
			 }
		}

		count++;
		diagtime2=650;
	}
	}
	return ret;
}


//wykrycie zwarcia calej galezi
uint8_t  shortdiag(uint8_t amoundstairs, uint16_t *s, uint8_t state)
{
	uint8_t ret=0, adrrtemp;
	static uint8_t count=0;
	static uint8_t adress=0, tempadress=0xff;
	uint16_t *wsk;
	static uint16_t z1, z2;

	wsk=s;

	if(state)
	{
	if(!diagtime3)
	{

		if(count>=amoundstairs)
		{
			count=0;
		}

		adress=count/4;
		if(adress!=tempadress)
		{
			 tempadress=adress;

			 adrrtemp=(amoundstairs-1)/4; //obliczenie ostatniego adresu
			 if(adrrtemp==tempadress) ret=1;
			 z1=Read_data_TPS(tempadress, 0x7D);
			 z2=Read_data_TPS(tempadress, 0x7E);
			 z2=(z2&0x0f);
			 z1=z1|(z2<<8);

			 uint8_t i=0;
			 for(int z=11; z>=0; z--)
			 {
				 wsk=(uint16_t *)(s+(tempadress*12)+i);
				 *wsk=(z1>>z)&(0x01);
				 i++;
			 }
		}

		count++;
		diagtime3=650;
	}
	}
	return ret;
}

//Funkcja stan diagnostyki za pomoca UART - BT
void BTsenddiagnostic(uint8_t *activdiagnostic, uint16_t val1, uint8_t val2, uint8_t val3, uint16_t *wsk1, uint16_t *wsk2, uint16_t *wsk3, uint8_t amoundofstairs)
{
	static uint8_t temp1=0, temp2=0, temp3=0;
	char stringtab[10];
	uint16_t *tempwsk1, *tempwsk2, *tempwsk3;

	if(val1) temp1=1;
	if(val2) temp2=1;
	if(val3) temp3=1;


	if(*activdiagnostic && temp1 && temp2 && temp3) //jezeli zostaly przeprowadzone pomiary oraz diangostyka diod led
	{
		*activdiagnostic=0;
		temp1=0;
		temp2=0;
		temp3=0;

		tempwsk1=wsk1;
		tempwsk2=wsk2;
		tempwsk3=wsk3;

		for(uint8_t i=0; i<(amoundofstairs*3); i++)
		{
			sendstring("Channel-");
			channeltosend(i, stringtab);
			sendstring(stringtab);
			valuetosend(*tempwsk1, stringtab);
			sendstring(stringtab);
			sendstring("\r\n");
			tempwsk1++;

			resetwatchdogtps(); //reset licznika watchdog poniewaz wysylanie danych moze trwac zbyt duzo czasu
			IWDG_ReloadCounter(); //reset watchdog systemowego
		}
		for(uint8_t i=0; i<(amoundofstairs*3); i++)
		{
			sendstring("Channel-");
			channeltosend(i, stringtab);
			sendstring(stringtab);
			sendstring("Openload:");
			if(*tempwsk2) sendstring("YES"); else sendstring("NO");
			sendstring("\r\n");
			tempwsk2++;

			resetwatchdogtps();  //reset licznika watchdog poniewaz wysylanie danych moze trwac zbyt duzo czasu
			IWDG_ReloadCounter(); //reset watchdog systemowego
		}
		for(uint8_t i=0; i<(amoundofstairs*3); i++)
		{
			sendstring("Channel-");
			channeltosend(i, stringtab);
			sendstring(stringtab);
			sendstring("Shorted:");
			if(*tempwsk3) sendstring("YES"); else sendstring("NO");
			sendstring("\r\n");
			tempwsk3++;

			resetwatchdogtps();  //reset licznika watchdog poniewaz wysylanie danych moze trwac zbyt duzo czasu
			IWDG_ReloadCounter(); //reset watchdog systemowego
		}
	}
}

//Przeliczenie wartosci napiec z wyjscia
void valuetosend(uint16_t value, char *s)
{
	uint16_t temp, temp2;

	*s=(char)(value/1000);
	temp2=value-((*s)*1000);
	*s=*s+0x30;
	s++;
	*s=(char)(temp2/100);
	temp=temp2-((*s)*100);
	*s=*s+0x30;
	s++;
	*s=',';
	s++;
	*s=temp/10;
	*s=*s+0x30;
	s++;
	*s=temp%10;
	*s=*s+0x30;
	s++;
	*s='V';
	s++;
	*s=' ';
	s++;
	*s=0x00; //zakonczneie stringu
}

//przeliczenie stringa numeru kanalu
void channeltosend(uint8_t channel, char *s)
{

	*s=(char)(channel/10);
	*s=*s+0x30;
	s++;
	*s=channel%10;
	*s=*s+0x30;
	s++;
	*s=':';
	s++;
	*s=0x00; //zakonczenie stringa
}

//Funkcja zalaczajaca diagnostyke w przypadku gdy jest ona wylaczona z jakiegos powodu
void enablediagnostic(void)
{
	for(uint8_t i=0; i<6; i++)
	{
		if(Read_data_TPS(i, 0x54)!=0xff)
		{
			Write_data_TPS(i, 0x54, 0xff);
		}
		if(Read_data_TPS(i, 0x55)!=0x0f)
		{
			Write_data_TPS(i, 0x55, 0x0f);
		}
	}
}

//Wykasowanie flag
uint8_t clearfaultflag(uint16_t *init1, uint16_t *init2, uint16_t *init3, uint8_t amound)
{
	static uint8_t init11=0, init22=0, init33=0, count=0;
	uint8_t ret=0;

	if(*init1)
		{
		init11=1;
		*init1=0;
		}
	if(*init2)
		{
		init22=1;
		*init2=0;
		}
	if(*init3)
		{
		 init33=1;
		 *init3=0;
		}

	if(init11 && init22 && init33 && (!timerclear))
	{
		timerclear=100;
		count++;
		if(count>=100) count=100;
		ret=1;
	}

	if(init11 && init22 && init33 && (count>=100))
	{
		init11=0;
		init22=0;
		init33=0;
		count=0;

		for(uint8_t i=0; i<(amound/4); i++)
		{
			Write_data_TPS(i, 0x60, 0x02);
		}
		ret=0;
	}
  return ret;
}


